using Gep.Api.Util;

namespace Gep.Api.Demo
{
    /// <summary>
    /// VCC虚拟卡api
    /// </summary>
    public class Vas
    {
        /// <summary>
        /// 开卡申请
        /// </summary>
        public static void Apply()
        {
            string path = "/api/vas/card/apply";
            Dictionary<string, string> dataContent = new Dictionary<string, string>
            {
                { "userReqNo", StringUtil.GenerateOrderNumber() },
                { "localCurrency", "USD" },
                { "startDate", DateTime.Now.ToString("yyyy-MM-dd") },
                { "endDate", "2026-12-31" },
                { "authLimitAmount", "100" },
                { "enableMultiUse", "1" },//1多次卡 0单次卡
                { "enableCurrencyCheck", "0" },//是否限制交易币种	1开启校验 0 不校验
                { "cardAlias", "消费" },
                { "binRangeId", "438357" }, ////测试环境使用HKG-438357,USA-404038                 
                { "channelType", "1" },//1(常规卡，默认) 2(共享-附属卡)
                { "groupId", "13800000000" },
                { "cardUserId", "2408070955000000409" }
            };
            ApiRequest.UserPost(path, dataContent);
        }

        /// <summary>
        /// 销卡申请
        /// </summary>
        public static void Close()
        {
            string path = "/api/vas/card/close";
            Dictionary<string, string> dataContent = new Dictionary<string, string>
            {
                { "userReqNo", StringUtil.GenerateOrderNumber() },
                { "cardId", "2411181813000002801" }
            };
            ApiRequest.UserPost(path, dataContent);
        }
        /// <summary>
        /// 卡充值
        /// </summary>
        public static void Recharge()
        {
            string path = "/api/vas/card/recharge";
            Dictionary<string, string> dataContent = new Dictionary<string, string>
            {
                { "userReqNo", StringUtil.GenerateOrderNumber() },
                { "cardId", "2411181813000002801" },
                { "authLimitAmount", "100" },//充值或授权额度
                { "channelType", "1" },// 1(常规卡，传空时默认) 2(共享卡)
                { "groupId", "" }//共享卡时必填
            };
            ApiRequest.UserPost(path, dataContent);
        }
        /// <summary>
        /// 卡退款
        /// </summary> 
        public static void Refund()
        {
            string path = "/api/vas/card/refund";
            Dictionary<string, string> dataContent = new Dictionary<string, string>
            {
                { "userReqNo", StringUtil.GenerateOrderNumber() },
                { "cardId", "2411181813000002801" },
                { "refundAmount", "100" },//退款金额
                { "channelType", "1" },// 1(常规卡，传空时默认) 2(共享卡)
                { "groupId", "" }//共享卡时必填
            };
            ApiRequest.UserPost(path, dataContent);
        }
        /// <summary>
        /// 卡组申请
        /// </summary>
        public static void ApplyCardGroup()
        {
            string path = "/api/vas/card/applyCardGroup";
            Dictionary<string, string> dataContent = new Dictionary<string, string>
            {
                { "userReqNo", StringUtil.GenerateOrderNumber() },
                { "ccy", "USD" },
                { "groupName", "测试卡组" },
                { "authMoney", "1000" },// 共享卡总额度
                { "country", "" }//共享卡区域支持USA(美国) HKG(香港) ALL(其他)
            };
            ApiRequest.UserPost(path, dataContent);
        }
        /// <summary>
        /// 卡组状态变更
        /// </summary>
        public static void UpdateCardGroupStatus()
        {
            string path = "/api/vas/card/updateCardGroupStatus";
            Dictionary<string, string> dataContent = new Dictionary<string, string>
            {
                { "userReqNo", StringUtil.GenerateOrderNumber() },
                { "groupId", "2408142021000000107" },
                { "status", "" }//0冻结 1启用 2注销卡
            };
            ApiRequest.UserPost(path, dataContent);
        }
        /// <summary>
        /// 卡片信息修改
        /// </summary>
        public static void ModifyCard()
        {
            string path = "/api/vas/card/modifyCard";
            Dictionary<string, string> dataContent = new Dictionary<string, string>
            {
                { "userReqNo", StringUtil.GenerateOrderNumber() },
                { "cardId", "2411181813000002801" },
                { "cardAlias", "卡别名" },
                { "cardLabel", "卡标签" },
                { "status", "" },//卡状态：0-冻结 1-启用
                { "authLimitAmount", "" }//卡片使用限额(常规卡需为空)
            };
            ApiRequest.UserPost(path, dataContent);
        }
        /// <summary>
        /// 持卡人申请
        /// </summary>
        public static void CardhodlerApply()
        {
            string path = "/api/vas/cardhodler/apply";
            Dictionary<string, string> dataContent = new Dictionary<string, string>
            {
                { "firstName", "ming" },
                { "middleName", "" },
                { "lastName", "xiao" },
                { "email", "mucang@baofu.com" },
                { "mobilePrefix", "86" },
                { "mobile", "13000000001" },
                { "birthDate", "2000-01-01" },
                { "countryCode", "HKG" },
                { "billingState", "Hong Kong" },
                { "billingCity", "New Territories" },
                { "billingAddress", "Horse Material Water, Shatin" },
                { "billingZipCode", "999077" },
                { "remark", "" }
            };
            ApiRequest.UserPost(path, dataContent);
        }
        /// <summary>
        /// 持卡人信息查询
        /// </summary>
        public static void CardhodlerInfo()
        {
            string path = "/api/vas/cardhodler/info";
            Dictionary<string, string> dataContent = new Dictionary<string, string>
            {
                { "cardUserId", "2406131332000000002" }
            };
            ApiRequest.UserPost(path, dataContent);
        }
        /// <summary>
        /// 持卡人删除
        /// </summary>
        public static void CardhodlerDrop()
        {
            string path = "/api/vas/cardhodler/drop";
            Dictionary<string, string> dataContent = new Dictionary<string, string>
            {
                { "cardUserId", "2408142012000000458" }
            };
            ApiRequest.UserPost(path, dataContent);
        }
        /// <summary>
        /// 卡片信息查询
        /// </summary>
        public static void Info()
        {
            string path = "/api/vas/card/info";
            Dictionary<string, string> dataContent = new Dictionary<string, string>
            {
                { "cardId", "2408080906000001109" }
            };
            ApiRequest.UserPost(path, dataContent);
        }
        /// <summary>
        /// 卡片图片查询
        /// </summary>
        public static void Img()
        {
            string path = "/api/vas/card/v2/img";
            Dictionary<string, string> dataContent = new Dictionary<string, string>
            {
                { "cardId", "2408080906000001109" }
            };
            ApiRequest.UserPost(path, dataContent, null, false);
        }
        /// <summary>
        /// 卡交易查询
        /// </summary>
        public static void TransQuery()
        {
            string path = "/api/vas/trans/v3/query";
            Dictionary<string, string> dataContent = new Dictionary<string, string>
            {
                { "cardType", "0" },//0:常规卡 1:共享卡
                { "cardId", "2408080906000001109" },
                { "beginTime", "2024-11-18 00:00:00" },
                { "endTime", "2024-11-18 23:59:59" },
                { "timeType", "0" },//0:根据交易时间查询 1:根据创建时间查询
                { "commonTransType", "" },//1:消费 2:冲正 3:退款 4:清算差额 5:冲正后请款 7:强制清算
                { "commonTransStatus", "1" },//1:批准 2:拒绝
                { "currentPage", "1" },
                { "pageSize", "10" },
                { "queryUserNo", "" }
            };
            ApiRequest.UserPost(path, dataContent);
        }
        /// <summary>
        /// 卡组信息查询
        /// </summary>
        public static void GroupCarddetail()
        {
            string path = "/api/vas/card/groupCarddetail";
            Dictionary<string, string> dataContent = new Dictionary<string, string>
            {
                { "groupId", "2408142021000000107" }
            };
            ApiRequest.UserPost(path, dataContent);
        }
        /// <summary>
        /// 卡操作查询
        /// </summary>
        public static void QueryCardOperate()
        {
            string path = "/api/vas/card/queryCardOperate";
            Dictionary<string, string> dataContent = new Dictionary<string, string>
            {
                { "userReqNo", "" },
                { "cardId", "2408080906000001109" },
                { "groupId", "" },
                { "status", "2" },//状态：0待处理 1处理中 2 成功 3失败
                { "opType", "" },//类型：0#开卡申请 1#充值 3#销卡 4#退款
                { "beginTime", "2024-11-11" },
                { "endTime", "2024-11-19" },
                { "currentPage", "1" },
                { "pageSize", "10" }
            };
            ApiRequest.UserPost(path, dataContent);
        }
        /// <summary>   
        /// 卡组操作查询
        /// </summary>
        public static void QueryCardGroupOperate()
        {
            string path = "/api/vas/card/queryCardGroupOperate";
            Dictionary<string, string> dataContent = new Dictionary<string, string>
            {
                { "userReqNo", "" },
                { "groupId", "" },
                { "status", "2" },//状态：0待处理 1处理中 2 成功 3失败
                { "opType", "" },//类型：0#开卡申请 1#充值 3#销卡 4#退款
                { "beginTime", "2024-11-11" },
                { "endTime", "2024-11-19" },
                { "currentPage", "1" },
                { "pageSize", "10" }
            };
            ApiRequest.UserPost(path, dataContent);
        }
        /// <summary>
        /// 平台推荐卡头查询
        /// </summary>
        public static void QuerySupportCardBins()
        {
            string path = "/api/vas/card/querySupportCardBins";
            Dictionary<string, string> dataContent = new Dictionary<string, string>
            {
                { "merchantName", "Amazon" }
            };
            ApiRequest.UserPost(path, dataContent);
        }
        /// <summary>
        /// 查询开卡量汇总
        /// </summary>
        public static void QueryCardSummary()
        {
            string path = "/api/vas/card/queryCardSummary";
            Dictionary<string, string> dataContent = new Dictionary<string, string>
            {
                { "queryUserNo", "5181200731000138828" }
            };
            ApiRequest.UserPost(path, dataContent);
        }
    }
}